local Object = {}

Object.__index = Object

function Object:extend()
	local c = {}
	for k, v in pairs(self) do
		if k:sub(1, 2) == "__" then
			c[k] = v
		end
	end
	c.__index = c
	return setmetatable(c, self)
end

function Object:new(...)
	local o = setmetatable({}, self)
	if o.initialize and type(o.initialize) == "function" then
		o:initialize(...)
	end
	return o
end

function Object:initialize()
end

function Object:isA(c)
	local m = getmetatable(self)
	while m do
		if m == c then
			return true
		end
		m = getmetatable(m)
	end
	return false
end

return Object