local Group = require "game.Group"
local Enemy = require "game.Enemy"

local EnemyGroup = Group:extend()

function EnemyGroup:setup(id)
	local data = dataGroups[id]
	-- Members
	self:clear()
	for _, v in ipairs(data.enemies) do
		self:addMember(Enemy:new(v))
	end
end

function EnemyGroup:setupBattlePosition()
	local size = self:getBattleSize()
	local rows = math.min(3, (size < 3 and size) or math.ceil(size / 2))
	local cols = math.ceil(size / rows)
	local aw = 288
	local ah = 144
	local ax = 64
	local ay = 160
	local cw = aw / cols
	local rh = (rows > 1 and ah / (rows - 1)) or ah
	for i, v in ipairs(self:getBattleMembers()) do
		local c = math.floor((i - 1) / rows)
		local r = (i - 1) % rows
		local s = ((c + 1 < cols or size % rows == 0) and rows) or size % rows
		local o = math.min(48, (s > 1 and cw / (s - 1)) or cw)
		local x = ax + c * cw + cw / 2 + (s - 1) * o / 2 - r * o
		local y = ay + ah / 2 + r * rh - (s - 1) * rh / 2
		v:setPosition(x, y)
	end
end

return EnemyGroup