local Object = require "core.Object"

local Result = Object:extend()

function Result:initialize()
    self.target = nil
    -- Success
    self.failed = false
    self.missed = false
    self.evaded = false
    -- Target
    self.alterHp = false
    self.alterMp = false
    self.hpValue = 0
    self.mpValue = 0
    -- User
    self.alterUserHp = false
    self.alterUserMp = false
    self.userHpValue = 0
    self.userMpValue = 0
    -- Statuses/buffs/debuffs
    self.addedStatuses = {}
    self.addedBuffs = {}
    self.addedDebuffs = {}
    self.removedStatuses = {}
end

function Result:isSuccess()
    if self.failed or self.missed or self.evaded then
        return false
    end
    if not self.alterHp and not self.alterMp then
        -- TODO
        if #self.addedStatuses + #self.addedBuffs + #self.addedDebuffs + #self.removedStatuses == 0 then
            return false
        end
    end
    return true
end

return Result