local Object = require "core.Object"
local JSON = require "core.JSON"

local DataManager = Object:extend()

function DataManager:initialize()
	function JSON:unsupportedTypeEncoder(v)
		return "null"
	end
end

function DataManager:save(name, data)
	local r, e = love.filesystem.write(name, JSON:encode(data, nil, {
		pretty = true,
		indent = "\t",
		align_keys = false,
		array_newline = true
	}))
	if not r then
		error(e)
	end
end

function DataManager:load(name)
	local r, e = love.filesystem.read(name)
	if not r then
		error(e)
	end
	return JSON:decode(r)
end

return DataManager