local WindowState = require "state.WindowState"
local AreaState = require "state.AreaState"
local ActionWindow = require "window.ActionWindow"

local TitleState = WindowState:extend()

function TitleState:initialize()
	WindowState.initialize(self)
	-- Window
	self.window = ActionWindow:new(240, 176, 160, 128, {
		{id = "NewGame", name = TM.TITLE_NEW_GAME},
		{id = "LoadGame", name = TM.TITLE_LOAD_GAME, enabled = false},
		{id = "Exit", name = TM.TITLE_EXIT}
	})
	self.window:setCallback("NewGame", function() self:actionNewGame() end)
	self.window:setCallback("LoadGame", function() self:actionLoadGame() end)
	self.window:setCallback("Exit", function() self:actionExit() end)
end

function TitleState:actionNewGame()
	-- Setup new game
	for _, v in ipairs(gameActors) do
		v:setupNewGame()
	end
	gameActorGroup:setupNewGame()
	-- TODO
	gameEnemyGroup:setup(1)
	-- TODO
	-- State
	-- TODO
	SM:pushState(AreaState:new())
	-- TODO
end

function TitleState:actionLoadGame()
	-- TODO
end

function TitleState:actionExit()
	SM:prevState()
end

function TitleState:start()
	WindowState.start(self)
	AM:playTitleMusic()
end

function TitleState:stop()
	if not SM:peekState() or SM:peekState():isA(AreaState) then
		gameTransition:fadeOut(64)
		self:closeWindows()
		AM:fadeMusic(64)
	else
		WindowState.stop(self)
	end
end

function TitleState:openWindows()
	self.window:open()
end

function TitleState:closeWindows()
	self.window:close()
end

function TitleState:updateWindows()
	self.window:update()
end

function TitleState:drawWindows()
	self.window:draw()
end

return TitleState