local State = require "state.State"

local WindowState = State:extend()

function WindowState:initialize()
	self.backgroundImage = RM:getSystemImage("background.png")
end

function WindowState:stop()
	State.stop(self)
	self:closeWindows()
end

function WindowState:openWindows()
end

function WindowState:closeWindows()
end

function WindowState:updateWindows()
end

function WindowState:update()
	if not gameTransition:isBusy() then
		self:openWindows()
	end
	State.update(self)
	self:updateWindows()
end

function WindowState:drawBackground()
	love.graphics.setShader()
	love.graphics.setColor(1, 1, 1)
	for y = 0, math.ceil(VM:getH() / 32) - 1 do
		for x = 0, math.ceil(VM:getW() / 32) - 1 do
			love.graphics.draw(self.backgroundImage, x * 32, y * 32)
		end
	end
end

function WindowState:drawWindows()
end

function WindowState:draw()
	self:drawBackground()
	self:drawWindows()
	State.draw(self)
end

return WindowState