local OptionWindow = require "window.OptionWindow"

local ActionWindow = OptionWindow:extend()

function ActionWindow:initialize(x, y, w, h, actions)
	OptionWindow.initialize(self, x, y, w, h)
	self.actions = actions or {}
end

function ActionWindow:isSelectEnabled()
	if self:hasCallback(self:getActionId()) then
		return true
	end
	return OptionWindow.isSelectEnabled(self)
end

function ActionWindow:isItemEnabled(index)
	return (self.actions[index].enabled == nil and true) or self.actions[index].enabled
end

function ActionWindow:getSize()
	return #self.actions
end

function ActionWindow:getActionId(index)
	return self.actions[index or self.index].id
end

function ActionWindow:setActions(actions)
	self.actions = actions or {}
end

function ActionWindow:select()
	local id = self:getActionId()
	if self:hasCallback(id) then
		self:invokeCallback(id)
	else
		OptionWindow.select(self)
	end
end

function ActionWindow:drawItem(index, x, y, w, h)
	self:drawText(self.actions[index].name, x, y, w, h, (self:isItemEnabled(index) and OptionWindow.COLOR_FG) or OptionWindow.COLOR_FG_DISABLED)
end

return ActionWindow