local InfoWindow = require "window.InfoWindow"

local AutoclosableInfoWindow = InfoWindow:extend()

function AutoclosableInfoWindow:initialize(x, y, w, h, text, alignment, duration)
	InfoWindow.initialize(self, x, y, w, h, text, alignment)
	self.duration = self.duration or 96
	self.timer = 0
end

function AutoclosableInfoWindow:setDuration(duration)
	self.duration = duration
end

function AutoclosableInfoWindow:update()
	InfoWindow.update(self)
	if self.visible and self.enabled and self:isOpen() then
		self.timer = self.timer + 1
		if self.timer >= self.duration then
			self.timer = 0
			self:close()
		end
	else
		self.timer = 0
	end
end

return AutoclosableInfoWindow