local OptionWindow = require "window.OptionWindow"

local BattleGroupWindow = OptionWindow:extend()

function BattleGroupWindow:getSize()
	return gameActorGroup:getBattleSize()
end

function BattleGroupWindow:getActorId(index)
	return gameActorGroup:getMember(index or self.index):getId()
end

function BattleGroupWindow:drawItem(index, x, y, w, h)
	local id = self:getActorId(index)
	local fw = self:getBattlefaceQuadW()
	local fh = self:getItemH()
	local fx = 0
	local fy = y + (h - fh) / 2
	local sw = 112
	local sh = self:getItemH()
	local sx1 = x + w - sw * 2 - self:getDefaultSpacing()
	local sx2 = x + w - sw
	local sy = y
	local nw = w - fw - sw * 2 - self:getDefaultSpacing() * 3
	local nh = self:getItemH()
	local nx = x + fw + self:getDefaultSpacing()
	local ny = y
	self:drawActorBattleface(id, fx, fy)
	self:drawActorName(id, nx, ny, nw, nh)
	self:drawActorHp(id, sx1, sy, sw, sh)
	self:drawActorMp(id, sx2, sy, sw, sh)
end

return BattleGroupWindow