local InfoWindow = require "window.InfoWindow"

local ClosableInfoWindow = InfoWindow:extend()

function ClosableInfoWindow:update()
	InfoWindow.update(self)
	if self.visible and self.enabled and self:isOpen() then
		if IM:isPressed("Select") or IM:isPressed("Cancel") then
			self:close()
			self:playSelectSound()
		end
	end
end

function ClosableInfoWindow:drawInterface()
	self:drawBottomArrow()
end

return ClosableInfoWindow