local Window = require "window.Window"

local InfoWindow = Window:extend()

function InfoWindow:initialize(x, y, w, h, text, alignment)
	Window.initialize(self, x, y, w, h)
	self.text = text or ""
	self.alignment = alignment or InfoWindow.ALIGN_LEFT
end

function InfoWindow:setText(text)
	self.text = text
end

function InfoWindow:setAlignment(alignment)
	self.alignment = alignment
end

function InfoWindow:drawContent()
	self:drawText(self.text, 0, 0, self:getContentW(), self:getContentH(), InfoWindow.COLOR_FG, self.alignment)
end

return InfoWindow