local OptionWindow = require "window.OptionWindow"

local ItemWindow = OptionWindow:extend()

function ItemWindow:initialize(x, y, w, h, list)
	OptionWindow.initialize(self, x, y, w, h)
	self.list = list or {}
end

function ItemWindow:isItemEnabled(index)
	local id = self:getItemId(index)
	if gameActorGroup:isInBattle() then
		return dataItems[id].usableInBattle
	end
	return dataItems[id].usable
end

function ItemWindow:getSize()
	return #self.list
end

function ItemWindow:getCols()
	return 2
end

function ItemWindow:getItemId(index)
	return self.list[index or self.index]
end

function ItemWindow:setList(list)
	self.list = list
end

function ItemWindow:drawItem(index, x, y, w, h)
	local id = self:getItemId(index)
	local aw = 48
	local ah = h
	local ax = x + w - aw
	local ay = y
	local nw = w - aw - self:getDefaultSpacing()
	local nh = h
	local nx = x
	local ny = y
	self:drawText(dataItems[id].name, nx, ny, nw, nh, (self:isItemEnabled(index) and ItemWindow.COLOR_FG) or ItemWindow.COLOR_FG_DISABLED)
	self:drawText(string.format("#%2d", gameActorGroup:getItemAmount(id)), ax, ay, aw, ah, (self:isItemEnabled(index) and ItemWindow.COLOR_FG) or ItemWindow.COLOR_FG_DISABLED, ItemWindow.ALIGN_RIGHT)
end

return ItemWindow