local OptionWindow = require "window.OptionWindow"

local SkillWindow = OptionWindow:extend()

function SkillWindow:initialize(x, y, w, h, list)
	OptionWindow.initialize(self, x, y, w, h)
	self.list = list or {}
end

function SkillWindow:isItemEnabled(index)
	local id = self:getSkillId(index)
	if gameActorGroup:isInBattle() then
		return dataSkills[id].usableInBattle and gameActorGroup:getMember(gameBattle:getIndex()):isSkillUsable(id)
	end
	-- TODO
	return dataSkills[id].usable
end

function SkillWindow:getSize()
	return #self.list
end

function SkillWindow:getCols()
	return 2
end

function SkillWindow:getSkillId(index)
	return self.list[index or self.index]
end

function SkillWindow:setList(list)
	self.list = list
end

function SkillWindow:drawItem(index, x, y, w, h)
	local id = self:getSkillId(index)
	local cw = 48
	local ch = h
	local cx = x + w - cw
	local cy = y
	local nw = w - cw - self:getDefaultSpacing()
	local nh = h
	local nx = x
	local ny = y
	self:drawText(dataSkills[id].name, nx, ny, nw, nh, (self:isItemEnabled(index) and SkillWindow.COLOR_FG) or SkillWindow.COLOR_FG_DISABLED)
	self:drawText(tostring(dataSkills[id].mpCost), cx, cy, cw, ch, (self:isItemEnabled(index) and SkillWindow.COLOR_FG) or SkillWindow.COLOR_FG_DISABLED, SkillWindow.ALIGN_RIGHT)
end

return SkillWindow